﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;

namespace XamComboEditorAdditionalFeatures
{
    public class PersonViewModel : INotifyPropertyChanged
    {
        ObservableCollection<Person> _people;
        public ObservableCollection<Person> People
        {
            get { return _people; }
            set
            {
                _people = value;
                RaisePropertyChanged("People");
            }
        }

        private ICommand _loadDataCommand;
        public ICommand LoadDataCommand
        {

            get { return _loadDataCommand ?? (_loadDataCommand = new RelayCommand(GeneratePeople)); }

        }

        public PersonViewModel()
        {
            GeneratePeople();
        }

        void GeneratePeople()
        {
            var isSelected = DateTime.Now.Millisecond % 2 == 0;
            var random = new Random();

            var list = new ObservableCollection<Person>()
                  {
                      new Person(){ID=random.Next(100,999), FirstName="John", LastName="Smith", IsSelected=isSelected },
                      new Person(){ID=random.Next(100,999), FirstName="Janel", LastName="Leverling", IsSelected=!isSelected},
                      new Person(){ID=random.Next(100,999), FirstName="Laura", LastName="Callahan", IsSelected=!isSelected},
                      new Person(){ID=random.Next(100,999), FirstName="Robert", LastName="King", IsSelected=isSelected},
                      new Person(){ID=random.Next(100,999), FirstName="Margaret", LastName="Peacock", IsSelected = isSelected },
                      new Person(){ID=random.Next(100,999), FirstName="Andrew", LastName="Fuller", IsSelected=!isSelected},
                      new Person(){ID=random.Next(100,999), FirstName="Anne", LastName="Dodsworth", IsSelected=!isSelected},
                      new Person(){ID=random.Next(100,999), FirstName="Nancy", LastName="Davolio", IsSelected=isSelected},
                      new Person(){ID=random.Next(100,999), FirstName="Naomi", LastName="Suyama", IsSelected=!isSelected},
                  };

            People = list;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        void RaisePropertyChanged(String propertyName)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
